// Wild Magic Source Code
// David Eberly
// http://www.geometrictools.com
// Copyright (c) 1998-2008
//
// This library is free software; you can redistribute it and/or modify it
// under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation; either version 2.1 of the License, or (at
// your option) any later version.  The license is available for reading at
// either of the locations:
//     http://www.gnu.org/copyleft/lgpl.html
//     http://www.geometrictools.com/License/WildMagicLicense.pdf
//
// Version: 4.7.0 (2008/09/15)

#ifndef CLIPMESH_H
#define CLIPMESH_H

#include "Wm4WindowApplication3.h"
using namespace Wm4;

class ClipMesh : public WindowApplication3
{
    WM4_DECLARE_INITIALIZE;

public:
    ClipMesh ();

    virtual bool OnInitialize ();
    virtual void OnTerminate ();
    virtual void OnIdle ();
    virtual bool OnKeyDown (unsigned char ucKey, int iX, int iY);

protected:
    void CreateScene ();
    void Update ();

    // A torus.
    std::vector<Vector3f> m_kTorusVerticesMS, m_kTorusVerticesWS;
    std::vector<int> m_kTorusIndices;
    Plane3f m_kPlane;

    NodePtr m_spkScene;
    TriMeshPtr m_spkTorus, m_spkMeshPlane;
    WireframeStatePtr m_spkWireframe;
    VertexColor3EffectPtr m_spkEffect;
    Culler m_kCuller;
    Attributes m_kAttr;
};

WM4_REGISTER_INITIALIZE(ClipMesh);

#endif
